#ifndef __DPRINTF__
#define __DPRINTF__

#include "stdio.h"
#include "string.h"
#include "stdint.h"
#include <stddef.h>
#include "stdbool.h"
#include <stdlib.h>
#include <stdarg.h>


#define SUPPORT_PRINTF          1
#define NOT_SUPPORT_PRINTF      0
// important define

#define  PERMISSION_PRINTF  NOT_SUPPORT_PRINTF


#if PERMISSION_PRINTF == SUPPORT_PRINTF
//void dputc(char c);
void dputs(char *str);
void dputh16(uint16_t val);
void dputh32(uint32_t val);

void _dprintf(char *fmt, ...);

#define printf _dprintf
#else
#define printf(...)


#endif
#endif
